VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsBitmap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'********************************************
'* clsBitmap.cls                            *
'* Version 1.1                              *
'* Simple bitmap handling facilities        *
'********************************************
Option Explicit

'Surface Variables
Public Surface As DirectDrawSurface7
Dim SurfaceDesc As DDSURFACEDESC2
Dim SurfaceRect As DxVBLib.RECT
Dim ColourKey As DDCOLORKEY
Dim BitmapFilename As String

Public X As Long, Y As Long
Public TransparencyEnabled As Boolean

'***************************
'Class Initialize and Terminate
'***************************
Private Sub Class_Terminate()
    Set Surface = Nothing
End Sub

'***************************
'Class Methods
'***************************
Public Function Load(Filename As String, ByRef DirectDrawEngine As clsDirectDraw) As Long
    On Error GoTo load_error
    Err.Clear
    'Load the Surface into memory
    Set Surface = Nothing
    SurfaceDesc.lFlags = DDSD_CAPS
    SurfaceDesc.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
    Set Surface = DirectDrawEngine.DirectDraw.CreateSurfaceFromFile(Filename, SurfaceDesc)
    If Surface Is Nothing Then GoTo load_error
    Surface.GetSurfaceDesc SurfaceDesc
    
    'Set the default rect to encompass the whole Surface
    With SurfaceRect
        .Top = 0
        .Left = 0
        .Right = SurfaceDesc.lWidth
        .Bottom = SurfaceDesc.lHeight
    End With
    
    Surface.SetColorKey DDCKEY_SRCBLT, ColourKey
    
    BitmapFilename = Filename
    Load = 0
    Exit Function
load_error:
    Load = Err.Number
End Function

Public Sub ResetSurfaceRect()
    With SurfaceRect
        .Top = 0
        .Left = 0
        .Right = SurfaceDesc.lWidth
        .Bottom = SurfaceDesc.lHeight
    End With
End Sub

Public Function Reset(ByRef DirectDrawEngine As clsDirectDraw) As Long
    On Error GoTo reset_error
    Err.Clear
    Set Surface = DirectDrawEngine.DirectDraw.CreateSurfaceFromFile(BitmapFilename, SurfaceDesc)
    Reset = 0
    Exit Function
reset_error:
    Reset = Err.Number
End Function

'**************************
'Class Properties
'**************************
Public Property Let TransparentColour(Colour As DDCOLORKEY)
    ColourKey = Colour
    Surface.SetColorKey DDCKEY_SRCBLT, Colour
End Property

Public Property Get TransparentColour() As DDCOLORKEY
    TransparentColour = ColourKey
End Property

Public Property Get Rectangle() As DxVBLib.RECT
    Rectangle = SurfaceRect
End Property

Public Property Let Rectangle(r As DxVBLib.RECT)
    SurfaceRect = r
End Property
